//
// File:        testDEM.C
// Author:      Remigiusz Trzaska
// e-mail:      remek@npac.syr.edu
// Created:     Thu Dec 19 1996
// Copyright Remigiusz Trzaska 1996 NPAC, Syracuse University

// Description:
// 


#ifndef lint
static const char *sccsid = "@(#)testTex.cc, Copyright NPAC Remigiusz Trzaska";
#endif

#include "Memory.h"
#include "wv.h"
#include <fstream.h>

unsigned char* data;

void ppmSave(char* name, unsigned char* data, int dimx, int dimy)
{
   ofstream outFile(name);
   outFile << "P6" << endl << dimx << ' ' <<  dimy << endl << "255" << endl;
   for(int y=0; y<dimy; y++)
      for(int x=0; x<dimx; x++) {
	 outFile.put(data[3*(dimx*y+x)]);
	 outFile.put(data[3*(dimx*y+x)+1]);
	 outFile.put(data[3*(dimx*y+x)+2]);
      }
   outFile.close();
}


int main(int, char* argv[])
{
   ifstream inFile(argv[1]);
   
   int x;
   int y;
   
   int maxy=512;

   
   NewVector(data, maxy*maxy*3, unsigned char);

   for(y=0; y<maxy; y++) 
      for(x=0; x<maxy; x++)
      {
	 unsigned char lsB;
	 inFile.get(lsB);
	 data[3*(y*maxy+x)]=lsB;
	 inFile.get(lsB);
	 data[3*(y*maxy+x)+1]=lsB;
	 inFile.get(lsB);
	 data[3*(y*maxy+x)+2]=lsB;
      }
   
   cerr << "Data read..." << endl;
   inFile.close();
   
   ppmSave("original.pgm", data, 512, 512);

   twv_t* compressor = new_twv(500, 500);
   unsigned char stream[4000000];
   int quality = atoi(argv[2]);
   int usedLen = 4000000;
   int retQ;

   if((retQ=enc_twv(compressor, data, stream, &usedLen, quality))>=0)
   {
      cerr << "Used length: " << usedLen 
	   << " Quality returned: " << retQ << endl;
   }
   else
   {
      cerr << "Compression failed" << endl;
      exit(1);
   }

   for(int scale = 1; scale < 8; scale = 2*scale)
   {
      cerr << "Scale is " << scale << endl;

      unsigned char* datadec;
      NewVector(datadec, maxy/scale * maxy/scale * 3, unsigned char);
      cerr << "after newmatrix\n";
      if(dec_twv(compressor, stream, &usedLen, datadec, quality, scale)<0)
	 cerr << "Decompression failed" << endl;
      cerr << "Used length: " << usedLen << endl;

      char buf[256];
      sprintf(buf, "processed%d.pgm", scale);
      ppmSave(buf, datadec, 512/scale, 512/scale);
      cerr << "after processedsave\n";
      
      delete datadec;
   }
   
      delete_twv(&compressor);
}
